/**
 * This file is part of GenomeView, a genome browser and annotation curator
 * 
 * Copyright (C) 2007-2013 Thomas Abeel and contributors
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 * Project: http://genomeview.org/
 */
package net.sf.genomeview.gui.menu.edit;

import java.awt.event.ActionEvent;
import java.util.Observable;

import javax.swing.ImageIcon;

import net.sf.genomeview.data.Model;
import net.sf.genomeview.gui.menu.AbstractModelAction;


/**
 * Action to zoom in on the chromosome view.
 * 
 * @author thpar
 *
 */
public class RedoAction extends AbstractModelAction{


    private static final long serialVersionUID = -1318894389028565654L;

    public RedoAction(Model model) {
        super("Redo", new ImageIcon(model.getClass().getResource("/images/redo.png")), model);
    }

    public void actionPerformed(ActionEvent arg0) {
        model.redo();
    }
    
    @Override
    public void update(Observable o, Object arg) {
        setEnabled(model.hasRedo());
        super.putValue(SHORT_DESCRIPTION, model.getRedoDescription());
    }
}
